Attribute VB_Name = "bArray"
Option Explicit

Public Sub AddArrayValue(ByRef m_Array() As Variant, Value As Variant, Optional Index As Long)
Dim i As Integer

' For single subscript arrays only

On Error GoTo errHandler

' Increase array bound by one to make room for new value
ReDim Preserve m_Array(UBound(m_Array) + 1)

' Move values as required to insert new value at index location
If Not IsMissing(Index) And (Index >= LBound(m_Array)) And (Index <= UBound(m_Array)) Then
  For i = UBound(m_Array) To Index + 1 Step -1
    m_Array(i) = m_Array(i - 1)
  Next i
End If

' Insert value
m_Array(Index) = Value

Exit Sub

errHandler:

' Most probable error is an undimensioned array
ReDim m_Array(0)
m_Array(0) = Value

End Sub
Public Function ArrayInitialized(m_Array As Variant) As Boolean
Dim X As Variant

' Raises error if array is not initialized and returns False

On Error GoTo errHandler

X = UBound(m_Array)

ArrayInitialized = True

Exit Function

errHandler:
ArrayInitialized = False

End Function
Public Sub DeleteArrayValue(m_Array() As Variant, Index As Integer)
Dim n As Long

' For single subscript arrays only

' Move points up one place in array to preserve sort order
For n = Index To UBound(m_Array) - 1
  m_Array(n) = m_Array(n + 1)
Next n

' Decrease array bound by one
Select Case UBound(m_Array)
  Case Is = 0
    Erase m_Array
  Case Else
    ReDim Preserve m_Array(UBound(m_Array) - 1)
End Select

End Sub

