VERSION 5.00
Begin VB.Form frmFind 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find"
   ClientHeight    =   2745
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   5205
   Icon            =   "frmFind.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2745
   ScaleWidth      =   5205
   ShowInTaskbar   =   0   'False
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   1215
      Top             =   2250
   End
   Begin VB.Frame framSearch 
      Height          =   2085
      Left            =   120
      TabIndex        =   12
      Top             =   30
      Width           =   4935
      Begin VB.TextBox txtValue 
         Height          =   315
         Left            =   1230
         TabIndex        =   5
         Top             =   1140
         Width           =   3495
      End
      Begin VB.ComboBox cmbOperators 
         Height          =   315
         Left            =   1230
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   720
         Width           =   885
      End
      Begin VB.ComboBox cmbFields 
         Height          =   315
         Left            =   1230
         Sorted          =   -1  'True
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   300
         Width           =   3495
      End
      Begin VB.OptionButton optSearchDirection 
         Caption         =   "Find &Last"
         Height          =   195
         Index           =   3
         Left            =   3780
         TabIndex        =   9
         Top             =   1650
         Width           =   945
      End
      Begin VB.OptionButton optSearchDirection 
         Caption         =   "Find &Next"
         Height          =   195
         Index           =   2
         Left            =   2595
         TabIndex        =   8
         Top             =   1650
         Width           =   1035
      End
      Begin VB.OptionButton optSearchDirection 
         Caption         =   "Find &Previous"
         Height          =   195
         Index           =   1
         Left            =   1215
         TabIndex        =   7
         Top             =   1650
         Width           =   1305
      End
      Begin VB.OptionButton optSearchDirection 
         Caption         =   "Find &First"
         Height          =   195
         Index           =   0
         Left            =   150
         TabIndex        =   6
         Top             =   1650
         Value           =   -1  'True
         Width           =   1095
      End
      Begin VB.Label lblValue 
         BackStyle       =   0  'Transparent
         Caption         =   "S&earch for:"
         Height          =   195
         Left            =   150
         TabIndex        =   4
         Top             =   1230
         Width           =   780
      End
      Begin VB.Label lblOperators 
         BackStyle       =   0  'Transparent
         Caption         =   "Co&mparison"
         Height          =   195
         Left            =   150
         TabIndex        =   2
         Top             =   780
         Width           =   825
      End
      Begin VB.Label lblFields 
         BackStyle       =   0  'Transparent
         Caption         =   "F&ields"
         Height          =   195
         Left            =   150
         TabIndex        =   0
         Top             =   330
         Width           =   405
      End
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   2250
      TabIndex        =   10
      Top             =   2250
      Width           =   1365
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "&Search"
      Default         =   -1  'True
      Height          =   375
      Left            =   3690
      TabIndex        =   11
      Top             =   2250
      Width           =   1365
   End
   Begin VB.Image imgIcon 
      Height          =   480
      Index           =   0
      Left            =   270
      Picture         =   "frmFind.frx":030A
      Top             =   2220
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgIcon 
      Height          =   480
      Index           =   1
      Left            =   660
      Picture         =   "frmFind.frx":0614
      Top             =   2220
      Visible         =   0   'False
      Width           =   480
   End
End
Attribute VB_Name = "frmFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private nSearchField As Long
Private nSearchDirection As SEARCH_DIRECTION
Private nSearchOperator As Long
Private v_SearchValue As Variant

Public frmParent As frmDatabase

Private m_Table As cTable

Public Property Set Table(TBL As cTable)

Set m_Table = TBL

PopulateFieldNames m_Table, cmbFields

End Property
Private Sub cmdCancel_Click()

Timer1.Enabled = False
UnloadForm Me

End Sub
Private Sub cmdSearch_Click()
Dim nRecordNumber As Long

' frmParent will handle the details of prompting user
' to save changes.

Hourglass True

nSearchField = cmbFields.ItemData(cmbFields.ListIndex)
v_SearchValue = txtValue.Text
nSearchOperator = cmbOperators.ItemData(cmbOperators.ListIndex)

With m_Table
  .SearchField = nSearchField
  .SearchOperator = nSearchOperator
  .SearchValue = v_SearchValue
  nRecordNumber = .Find(nSearchDirection)
  If nRecordNumber = 0 Then
    Hourglass False
    Exit Sub
  End If
  frmParent.Reposition MOVE_RECORDNUMBER, nRecordNumber
End With

Hourglass False

End Sub
Private Sub Form_Activate()

Timer1.Enabled = True

End Sub
Private Sub Form_Load()

optSearchDirection(FIND_FIRST).Value = True
nSearchDirection = FIND_FIRST

With cmbOperators
  .AddItem "="
  .ItemData(.NewIndex) = EQUAL
  .AddItem "<>"
  .ItemData(.NewIndex) = NOT_EQUAL
  .AddItem "<"
  .ItemData(.NewIndex) = LESS_THAN
  .AddItem ">"
  .ItemData(.NewIndex) = GREATER_THAN
  .AddItem "<="
  .ItemData(.NewIndex) = LESS_THAN_OR_EQUAL
  .AddItem ">="
  .ItemData(.NewIndex) = GREATER_THAN_OR_EQUAL
  .ListIndex = 0
End With

End Sub
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

SaveWindowPosition Me

End Sub
Private Sub optSearchDirection_Click(Index As Integer)

nSearchDirection = Index

End Sub
Private Sub Timer1_Timer()
Static iIndex As Integer

If iIndex = 0 Then
  iIndex = 1
Else
  iIndex = 0
End If

Icon = imgIcon(iIndex).Picture

End Sub
Private Sub txtValue_GotFocus()

SelectAllText txtValue

End Sub
